# pcgames.tcl v1.2 by domsen <domsen@domsen.org> (c)2oo1
#
# comments? bugs? ideas? plz mail me :)
#
# liest die gaming news von www.pcgames.de aus und gibt
# sie wieder... auf abruf den passenden link und auf wunsch
# werden neue newslines geposted. siehe heise.tcl und meine
# anderen newsposter.
#
# usage:
#
# .pcgames - ruft die 'pcgameslimit' newslines ab
# .pcgameslink <nr> - sucht den passenden link zur newsline
# pcgameslimit - "" fr unbegrenzt, ratsam ist ein wert von 10
# pcgnewspost - 1 fr newsposting an, 0 fr aus
# pcgameschans - die channels in denen das tcl aktiv ist
# ispcgameshub legt fest ob der bot newshub ist oder nicht, das
# leaf tcl ist auch auf www.domsen.org verfgbar.
#
# pcgamesleafs sind die nicks der leafbots auf denen das leaf tcl
# luft
#
# man htte dieses tcl auch simpler coden knnen durch den
# gebrauch von regusbs und wget, aber das wre zu einfach
# gewesen da man die regsub-strings aus den php backends
# benutzen knnte - wo bleibt da die herausforderung. wget
# ist auerdem nicht auf allen shells erlaubt, also habe ich
# mich fr lynx entschieden. die tcl http lib wollte ich auch
# nicht benutzen, da ich gerne auf fremden externen code
# vollkommen verzichte :-)
#
####### config ######################

set pcgtrigger ".pcgames"
set pcgameschans ""
set pcgameslimit "10"
set pcgsearchtrigger ".pcgameslink"
set pcgnewspost "1"
set ispcgameshub "1"
set pcgamesleafs ""

####### ende der config #############

bind msg - $pcgtrigger msg_pcg
bind pub - $pcgtrigger pub_pcg
bind msg - $pcgsearchtrigger pcgmsgsearch
bind pub - $pcgsearchtrigger pcgpubsearch
bind time - "?0 * * * *" pcgcheck

proc sendpcgamesnews { arg } {
global pcgamesleafs
foreach bot [bots] {
if {([lsearch -exact [string tolower $pcgamesleafs] [string tolower $bot]] != -1)} {
putbot $bot "pcgames: $arg"
}}}


proc pcgcheck { nick uhost hand chan arg } {
global pcgameschans pcgnewspost ispcgameshub
set pcghdlfile "pcgames.hdl"
set pcgoldnews "none"
if {$pcgnewspost == 1 } {
if {[file exists $pcghdlfile]} {
putlog "pcgames: suche nach neuer newsline"
set counter 0
set temp2 [open "pcgames.hdl" r]
while { [eof $temp2] != "1" } {
set zeile "[gets $temp2]"
if { [string first "NEWS -" $zeile] != "-1" } {
incr counter }
if { ($counter == "1") && ($zeile != "") && [string first "]" $zeile] != "-1"} {
set pcgoldnews [string range $zeile 7 [string length $zeile]]
incr counter }
}
close $temp2 }
exec lynx -preparsed -dump http://www.pcgames.de/ > pcgames.hdl
set counter 0
if {$pcgoldnews == "none" } { 
putlog "pcgames: headlinefile created"
return 0 
}
set temp2 [open "pcgames.hdl" r]
while { [eof $temp2] != "1" } {
set zeile "[gets $temp2]"
if { [string first "NEWS -" $zeile] != "-1" } {
incr counter }
if { [string first "News-bersicht" $zeile] != "-1" } {
incr counter }
if { ($counter == "1") && ($zeile != "") && [string first "]" $zeile] != "-1"} {
set pcgnewnews [string range $zeile 7 [string length $zeile]]
if {$pcgoldnews == $pcgnewnews} { incr counter }
if {$pcgoldnews != $pcgnewnews} {
putlog "pcgames: neue newsline"
if { $ispcgameshub == "1" } { sendpcgamesnews $pcgnewnews }
foreach chan [channels] {
if {$pcgameschans == "" } { putserv "privmsg $chan :(neue pcgames newsline) $pcgnewnews" }
if {$pcgameschans != "" } {
if {([lsearch -exact [string tolower $pcgameschans] [string tolower $chan]] != -1) || ($pcgameschans == "")} {
putserv "privmsg $chan :(neue pcgames newsline) $pcgnewnews"
}}}}}}
close $temp2
}}


proc pcgmsgsearch {nick uhost hand arg } {
global pcgnewspost
exec lynx -preparsed -dump http://www.pcgames.de/ > pcgames.temp
set newsline 0
set counter 0
set linknr ""
if {$pcgnewspost == "1"} {
set temp2 [open "pcgames.temp" r]
while { [eof $temp2] != "1" } {
set zeile "[gets $temp2]"
if { [string first "NEWS -" $zeile] != "-1" } {
incr counter }
if { [string first "News-bersicht" $zeile] != "-1" } {
incr counter }
if { ($counter == "1") && ($zeile != "") && [string first "]" $zeile] != "-1"} {
incr newsline 
if {$newsline == $arg} {
set position [string first "]" $zeile]
incr position -2
set linknr "[string range $zeile $position [incr position 1]]. http://www.pcgames.de/index.cfm"
}
}
if { ([string first $linknr $zeile] != -1) && ($linknr != "")} {
set pcghyperlink [string range $zeile 6 [string length $zeile]]
putserv "privmsg $nick :$pcghyperlink"
putlog "pcgames: link search by $nick"
return 0
}
}
close $temp2
}
}




proc pcgpubsearch {nick uhost hand chan arg } {
global pcgnewspost pcgameschans
if {([lsearch -exact [string tolower $pcgameschans] [string tolower $chan]] != -1) || ($pcgameschans == "")} {
exec lynx -preparsed -dump http://www.pcgames.de/ > pcgames.temp
set newsline 0
set counter 0
set linknr ""
if {$pcgnewspost == "1"} {
set temp2 [open "pcgames.temp" r]
while { [eof $temp2] != "1" } {
set zeile "[gets $temp2]"
if { [string first "NEWS -" $zeile] != "-1" } {
incr counter }
if { [string first "News-bersicht" $zeile] != "-1" } {
incr counter }
if { ($counter == "1") && ($zeile != "") && [string first "]" $zeile] != "-1"} {
incr newsline 
if {$newsline == $arg} {
set position [string first "]" $zeile]
incr position -2
set linknr "[string range $zeile $position [incr position 1]]. http://www.pcgames.de/index.cfm"
}
}
if { ([string first $linknr $zeile] != -1) && ($linknr != "")} {
set pcghyperlink [string range $zeile 6 [string length $zeile]]
putserv "notice $nick :$pcghyperlink"
putlog "pcgames: link search by $nick on $chan"
return 0
}}
close $temp2
}}}





proc msg_pcg { nick uhost hand arg } {
global pcgameslimit
exec lynx -preparsed -dump http://www.pcgames.de/ > pcgames.temp
if {($arg == "") && ($pcgameslimit != "")} {
putlog "pcgames: sent last $pcgameslimit newslines to $nick"
set counter 0
set newslinenr 0
set temp2 [open "pcgames.temp" r]
putserv "privmsg $nick :heutige pcgames.de news"
while { [eof $temp2] != "1" } {
set zeile "[gets $temp2]"
if { [string first "NEWS -" $zeile] != "-1" } {
incr counter }
if { [string first "News-bersicht" $zeile] != "-1" } {
incr counter }
if { ($counter == "1") && ($zeile != "") && [string first "]" $zeile] != "-1"} {
set news [string range $zeile 7 [string length $zeile]]
if {$newslinenr < $pcgameslimit } {
incr newslinenr 
putserv "privmsg $nick :$newslinenr $news"
}}}
close $temp2
}
if {($arg == "all") || ($pcgameslimit == "")} {
putlog "pcgames: sent all newslines to $nick"
set counter 0
set newslinenr 0
set temp2 [open "pcgames.temp" r]
putserv "privmsg $nick :heutige pcgames.de news"
while { [eof $temp2] != "1" } {
set zeile "[gets $temp2]"
if { [string first "NEWS -" $zeile] != "-1" } {
incr counter }
if { [string first "News-bersicht" $zeile] != "-1" } {
incr counter }
if { ($counter == "1") && ($zeile != "") && [string first "]" $zeile] != "-1"} {
set news [string range $zeile 7 [string length $zeile]]
incr newslinenr 
putserv "privmsg $nick :$newslinenr $news"
}}
close $temp2
}}



proc pub_pcg { nick uhost hand chan arg } {
global pcgameschans pcgameslimit
if {([lsearch -exact [string tolower $pcgameschans] [string tolower $chan]] != -1) || ($pcgameschans == "")} {
exec lynx -preparsed -dump http://www.pcgames.de/ > pcgames.temp
if {($arg == "") && ($pcgameslimit != "")} {
putlog "pcgames: sent last $pcgameslimit newslines to $nick"
set counter 0
set newslinenr 0
set temp2 [open "pcgames.temp" r]
putserv "notice $nick :heutige pcgames.de news"
while { [eof $temp2] != "1" } {
set zeile "[gets $temp2]"
if { [string first "NEWS -" $zeile] != "-1" } {
incr counter }
if { [string first "News-bersicht" $zeile] != "-1" } {
incr counter }
if { ($counter == "1") && ($zeile != "") && [string first "]" $zeile] != "-1"} {
set news [string range $zeile 7 [string length $zeile]]
if {$newslinenr < $pcgameslimit } {
incr newslinenr 
putserv "notice $nick :$newslinenr $news"
}}}
close $temp2
}
if {($arg == "all") || ($pcgameslimit == "")} {
putlog "pcgames: sent all newslines to $nick"
set counter 0
set newslinenr 0
set temp2 [open "pcgames.temp" r]
putserv "notice $nick :heutige pcgames.de news"
while { [eof $temp2] != "1" } {
set zeile "[gets $temp2]"
if { [string first "NEWS -" $zeile] != "-1" } {
incr counter }
if { [string first "News-bersicht" $zeile] != "-1" } {
incr counter }
if { ($counter == "1") && ($zeile != "") && [string first "]" $zeile] != "-1"} {
set news [string range $zeile 7 [string length $zeile]]
incr newslinenr 
putserv "notice $nick :$newslinenr $news"
}}
close $temp2
}}}

putlog "*** pcgames.tcl v1.o by domsen succesfully loaded"

# [EOF]

